"use strict";

//Utile pour trouver les variables globales assignées qui ne devraient pas l'être
/*
window.__defineSetter__('name', function()
{
    debugger;
});
*/

var remote = require('remote');
var fileSystem = require('fs');
var dialog = remote.require('dialog');

var $ = require('global/js/library/jquery-2.1.3.js');
var jQuery = $;

var JSON5 = require('global/js/library/json5-v0.4.6/lib/json5.js');

var howler = require('global/js/library/howler.js-2.0/howler.min.js');

var sprintf = require('global/js/library/sprintf.js').sprintf;
var vsprintf = require('global/js/library/sprintf.js').vsprintf;

var appBasePath = remote.getCurrentWindow().appBasePath;
var rpDebug = remote.getCurrentWindow().rpDebug;

/*
window.onerror = function(message, url, lineNumber)
{
	try
	{
		rpEngine.logger.log(message, [test], rp.Logger.LEVEL_ERROR, rp.Logger.SUBJECT_ENGINE);
		return true;
	}
	catch (exception)
	{
		throw exception;
	    return false;
	}
};
*/

$(window).keydown(function(event)
{
	//F5
	if (event.keyCode == 116)
	{
		rpEngine.quickSave();
	}
	//F9
	else if (event.keyCode == 120)
	{
		rpEngine.quickLoad();
	}
	//F12
	else if (event.keyCode == 123)
	{
		remote.getCurrentWindow().toggleDevTools();
	}
	//Ctrl-S
	else if ((event.keyCode == 83) && (event.ctrlKey == true))
	{
		rpEngine.saveGame();
	}
	//Ctrl-L
	else if ((event.keyCode == 76) && (event.ctrlKey == true))
	{
		rpEngine.loadGame();
	}
});

Function.prototype.inheritsFrom = function(parentClass)
{
	$.extend(this.prototype, new parentClass());
	this.prototype.constructor = this;
	this.prototype.parent = parentClass.prototype;
	
	return this;
}

var rp = {};

rp.AssetManager = require('global/js/asset/AssetManager.js');
rp.AssetPack = require('global/js/asset/AssetPack.js');
rp.LangManager = require('global/js/asset/lang/LangManager.js');
rp.LangPack = require('global/js/asset/lang/LangPack.js');
rp.SoundEngine = require('global/js/asset/sound/SoundEngine.js');

rp.Config = require('global/js/data/Config.js');

rp.Game = require('global/js/data/game/Game.js');
rp.Actor = require('global/js/data/game/actor/Actor.js');
rp.ActorEffect = require('global/js/data/game/actor/ActorEffect.js');
rp.ActorStat = require('global/js/data/game/actor/ActorStat.js');
rp.ActorStatCategory = require('global/js/data/game/actor/ActorStatCategory.js');
rp.ActorStatTemplate = require('global/js/data/game/actor/ActorStatTemplate.js');
rp.Inventory = require('global/js/data/game/inventory/Inventory.js');
rp.InventoryItem = require('global/js/data/game/inventory/InventoryItem.js');
rp.InventoryItemCategory = require('global/js/data/game/inventory/InventoryItemCategory.js');
rp.InventoryItemTemplate = require('global/js/data/game/inventory/InventoryItemTemplate.js');
rp.NarrativeAction = require('global/js/data/game/action/NarrativeAction.js');
rp.NarrativeActionImageSelectionData = require('global/js/data/game/action/NarrativeActionImageSelectionData.js');
rp.NarrativeActionTextInputData = require('global/js/data/game/action/NarrativeActionTextInputData.js');
rp.Node = require('global/js/data/game/node/Node.js');
rp.NodeTemplate = require('global/js/data/game/node/NodeTemplate.js');

rp.ActorSave = require('global/js/data/game/save/ActorSave.js');
rp.ActorStatSave = require('global/js/data/game/save/ActorStatSave.js');
rp.GameSave = require('global/js/data/game/save/GameSave.js');
rp.InventoryItemSave = require('global/js/data/game/save/InventoryItemSave.js');
rp.InventorySave = require('global/js/data/game/save/InventorySave.js');
rp.NarrativeActionImageSelectionDataSave = require('global/js/data/game/save/NarrativeActionImageSelectionDataSave.js');
rp.NarrativeActionSave = require('global/js/data/game/save/NarrativeActionSave.js');
rp.NarrativeActionTextInputDataSave = require('global/js/data/game/save/NarrativeActionTextInputDataSave.js');
rp.NodeSave = require('global/js/data/game/save/NodeSave.js');
rp.SoundEngineSave = require('global/js/data/game/save/SoundEngineSave.js');
rp.TextTokenLangSave = require('global/js/data/game/save/TextTokenLangSave.js');
rp.TextTokenRawSave = require('global/js/data/game/save/TextTokenRawSave.js');
rp.TextTokenLang = require('global/js/data/game/text/TextTokenLang.js');
rp.TextTokenRaw = require('global/js/data/game/text/TextTokenRaw.js');

rp.Module = require('global/js/data/module/Module.js');
rp.ModuleManager = require('global/js/data/module/ModuleManager.js');

rp.GameScreen = require('global/js/gui/game/GameScreen.js');
rp.GameScreenMainMenu = require('global/js/gui/game/GameScreenMainMenu.js');
rp.GameScreenMainPanel = require('global/js/gui/game/GameScreenMainPanel.js');
rp.GameScreenSystemMenu = require('global/js/gui/game/GameScreenSystemMenu.js');
rp.InventoryPanel = require('global/js/gui/game/InventoryPanel.js');
rp.InventoryPanelSub = require('global/js/gui/game/InventoryPanelSub.js');
rp.PopupImageSelection = require('global/js/gui/game/PopupImageSelection.js');
rp.PopupShadow = require('global/js/gui/game/PopupShadow.js');
rp.PopupTextInput = require('global/js/gui/game/PopupTextInput.js');
rp.PlayerCharacterPanel = require('global/js/gui/game/PlayerCharacterPanel.js');

rp.TitleScreen = require('global/js/gui/title/TitleScreen.js');

rp.Util = require('global/js/util/Util.js');
rp.Logger = require('global/js/util/Logger.js');

rp.RpEngine = require('global/js/RpEngine.js')

var rpModule = null;
var rpGlobalScriptMap = null;

var rpEngine = new (rp.RpEngine);
rpEngine.init();