//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function ActorStatCategory(id)
{
	this._id = id;

	this._actorStatTemplateChildMap = {};
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

ActorStatCategory.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	_id : '',
	
	_langNameId : '',
	
	_isVisible : false,
	_order : 0,
	
	_actorStatTemplateChildMap : null,

	//------------------------------------------------------------------------------------------------------------
	//INITIALIZERS - SERIALIZERS
	//------------------------------------------------------------------------------------------------------------

	initFromFile : function(data)
	{
		this._langNameId = ((data.langNameId != null) ? data.langNameId : '');
		this._isVisible = ((data.isVisible != null) ? data.isVisible : true);
		this._order = ((data.order != null) ? data.order : 1);
	},
	
	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------

	getActorStatTemplateChildMap : function()
	{
		return this._actorStatTemplateChildMap;
	},
	
	getId : function()
	{
		return this._id;
	},

	getIsVisible : function()
	{
		return this._isVisible;
	},

	getLangName : function()
	{
		return ((this._langNameId != '') ? rpEngine.langManager.getPackGame().getString(this._langNameId) : '');
	},

	getLangNameId : function()
	{
		return this._langNameId;
	},
	
	getOrder : function()
	{
		return this._order;
	},
	
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = ActorStatCategory;

//------------------------------------------------------------------------------------------------------------