//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function InventoryItem()
{
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

InventoryItem.create = function(parentInventory, inventoryItemTemplate, itemCountUnequipped, itemCountEquipped)
{
	var inventoryItem = new InventoryItem();
	
	inventoryItem._parentInventory = parentInventory;
	inventoryItem._inventoryItemTemplate = inventoryItemTemplate;
	
	inventoryItem._itemCountEquipped = itemCountEquipped;
	inventoryItem._itemCountUnequipped = itemCountUnequipped;
	
	return inventoryItem;
}

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

InventoryItem.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	_parentInventory : null,
	_inventoryItemTemplate : null,
	
	_itemCountEquipped : 0,
	_itemCountUnequipped : 0,
	
	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
	
	getId : function()
	{
		return this._inventoryItemTemplate.getId();
	},
	
	getInventoryItemTemplate : function()
	{
		return this._inventoryItemTemplate;
	},
	
	getItemCountEquipped : function()
	{
		return this._itemCountEquipped;
	},
	setItemCountEquipped : function(value)
	{
		this._itemCountEquipped = value;
	},

	getItemCountTotal : function()
	{
		return this._itemCountEquipped + this._itemCountUnequipped;
	},
	
	getItemCountUnequipped : function()
	{
		return this._itemCountUnequipped;
	},
	setItemCountUnequipped : function(value)
	{
		this._itemCountUnequipped = value;
	},
	
	getParentInventory : function()
	{
		return this._parentInventory;
	},
	
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = InventoryItem;

//------------------------------------------------------------------------------------------------------------