//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function InventoryItemCategory(id)
{
	this._id = id;
	
	this._inventoryItemTemplateMap = {};
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

InventoryItemCategory.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	_id : '',
	
	_langNameId : '',
	
	_order : 0,
	
	_inventoryItemTemplateMap : null,
	
	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	initFromFile : function(data)
	{
		this._langNameId = ((data.langNameId != null) ? data.langNameId : '');
		this._isVisible = ((data.isVisible != null) ? data.isVisible : true);
		this._order = ((data.order != null) ? data.order : 1);
	},
	
	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
	
	getId : function()
	{
		return this._id;
	},

	getInventoryItemTemplateMap : function()
	{
		return this._inventoryItemTemplateMap;
	},
	
	getLangName : function()
	{
		return ((this._langNameId != '') ? rpEngine.langManager.getPackGame().getString(this._langNameId) : '');
	},

	getLangNameId : function()
	{
		return this._langNameId;
	},
	
	getOrder : function()
	{
		return this._order;
	},
	
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = InventoryItemCategory;

//------------------------------------------------------------------------------------------------------------