//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function Node()
{
	this._variableMap = {};
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

Node.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	_id : '',
	
	_nodeTemplate : null,

	_variableMap : null,
	
	//------------------------------------------------------------------------------------------------------------
	//INITIALIZERS - SERIALIZERS
	//------------------------------------------------------------------------------------------------------------

	initFromTemplate : function(nodeTemplate)
	{
		this._id = nodeTemplate.getId();
		this._nodeTemplate = nodeTemplate;
	},
	
	readFromSave : function(data)
	{
		this._variableMap = data.variableMap;
	},
	
	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
	
	getId : function()
	{
		return this._id;
	},
	
	getNodeTemplate : function()
	{
		return this._nodeTemplate;
	},

	getVariable : function(variableId)
	{
		return this._variableMap[variableId];
	},
	getVariableMap : function()
	{
		return this._variableMap;
	},
	setVariable : function(variableId, value)
	{
		this._variableMap[variableId] = value;
	},
	
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = Node;

//------------------------------------------------------------------------------------------------------------