//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function NarrativeActionSave(narrativeAction)
{
	this.narrativeActionImageSelectionDataSaveList = [];
	this.narrativeActionTextInputDataSaveList = [];
	
	this.options = {};
	
	//Write data

	this.id = narrativeAction.getId();
	
	this.langDescriptionId = narrativeAction.getLangDescriptionId();
	this.langInfoId = narrativeAction.getLangInfoId();
	this.langTitleId = narrativeAction.getLangTitleId();
	
	this.functionName = narrativeAction.getFunctionName();

	var narrativeActionImageSelectionDataList = narrativeAction.getNarrativeActionImageSelectionDataList();
	for (var key in narrativeActionImageSelectionDataList)
	{
		this.narrativeActionImageSelectionDataSaveList.push(new rp.NarrativeActionImageSelectionDataSave(narrativeActionImageSelectionDataList[key]));
	}

	var narrativeActionTextInputDataList = narrativeAction.getNarrativeActionTextInputDataList();
	for (var key in narrativeActionTextInputDataList)
	{
		this.narrativeActionTextInputDataSaveList.push(new rp.NarrativeActionTextInputDataSave(narrativeActionTextInputDataList[key]));
	}
	
	this.options = narrativeAction.getOptions();
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

NarrativeActionSave.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	id : '',
	
	langDescriptionId : '',
	langInfoId : '',
	langTitleId : '',
	
	functionName : '',

	narrativeActionImageSelectionDataSaveList : null,
	narrativeActionTextInputDataSaveList : null,
	
	options : null,
	
	//------------------------------------------------------------------------------------------------------------
	//INITIALIZERS - SERIALIZERS
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
		
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = NarrativeActionSave;

//------------------------------------------------------------------------------------------------------------