//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function ModuleManager()
{
	rpEngine.logger.log('Creating ModuleManager...', [], rp.Logger.LEVEL_DEBUG, rp.Logger.SUBJECT_ENGINE);
	
	this._currentData = new rp.Module();
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

ModuleManager.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------
	
	_currentData : null,

	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	formatCurrentModuleFilePath : function(filePath)
	{
		return this._currentData.formatSubFilePath(filePath);
	},

	formatCurrentModuleFilePathUrl : function(filePath)
	{
		return (appBasePath + this.formatCurrentModuleFilePath(filePath)).replace(/\\/g, '/');
	},

	loadModuleData : function()
	{
		rpEngine.logger.log('Loading module data...', [], rp.Logger.LEVEL_DEBUG, rp.Logger.SUBJECT_ENGINE);
		
		this._currentData.loadFile('module/');

		rpEngine.logger.log('Module data loaded successfully...', [], rp.Logger.LEVEL_DEBUG, rp.Logger.SUBJECT_ENGINE);
	},
		
	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
	
	getCurrentData : function()
	{
		return this._currentData;
	},

	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = ModuleManager;

//------------------------------------------------------------------------------------------------------------