//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function GameScreen()
{
	this._gameScreenMainMenu = new rp.GameScreenMainMenu();
	this._gameScreenSystemMenu = new rp.GameScreenSystemMenu();
	this._inventoryPanel = new rp.InventoryPanel();
	this._mainPanel = new rp.GameScreenMainPanel();
	this._popupImageSelection = new rp.PopupImageSelection();
	this._popupShadow = new rp.PopupShadow();
	this._popupTextInput = new rp.PopupTextInput();
	this._playerCharacterPanel = new rp.PlayerCharacterPanel();
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

GameScreen.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	_gameScreenMainMenu : null,
	_gameScreenSystemMenu : null,
	_inventoryPanel : null,
	_mainPanel : null,
	_playerCharacterPanel : null,
	_popupImageSelection : null,
	_popupShadow : null,
	_popupTextInput : null,
	
	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	resetGui : function()
	{
		$('#popupShadow').hide();
		$('#game_popupImageSelection').hide();
		$('#game_popupTextInput').hide();
		$('#game_inventoryPanel').hide();
		$('#game_playerCharacterPanel').hide();
		$('#game_popupSystemMenu').hide();
		$('#game_mainMenu_btnCharacter').removeClass('toggle');
		$('#game_mainMenu_btnInventory').removeClass('toggle');
		$('#game_mainMenu_btnJournal').removeClass('toggle');
		$('#game_mainMenu_btnSystemMenu').removeClass('toggle');
	},
	
	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
	
	getGameScreenMainMenu : function()
	{
		return this._gameScreenMainMenu;
	},

	getGameScreenSystemMenu : function()
	{
		return this._gameScreenSystemMenu;
	},
	
	getInventoryPanel : function()
	{
		return this._inventoryPanel;
	},
	
	getMainPanel : function()
	{
		return this._mainPanel;
	},

	getPlayerCharacterPanel : function()
	{
		return this._playerCharacterPanel;
	},
	
	getPopupImageSelection : function()
	{
		return this._popupImageSelection;
	},

	getPopupShadow : function()
	{
		return this._popupShadow;
	},

	getPopupTextInput : function()
	{
		return this._popupTextInput;
	},
	
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = GameScreen;

//------------------------------------------------------------------------------------------------------------
