//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function Logger()
{
	rp.Util.createDirectory(appBasePath + 'log');
	this.logFilePath = appBasePath + 'log/log_' + rp.Util.getCurrentDatetime(false) + '.txt';
	
	this.log('Creating log file "%s"...', [this.logFilePath], rp.Logger.LEVEL_DEBUG, rp.Logger.SUBJECT_ENGINE);
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

Logger.LEVEL_DEBUG = 'debug';
Logger.LEVEL_ERROR = 'error';
Logger.LEVEL_WARNING = 'warning';

Logger.SUBJECT_UNDEFINED = 'undefined';
Logger.SUBJECT_ENGINE = 'engine';
Logger.SUBJECT_GAME = 'game';

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

Logger.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	logFilePath : '',
	
	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	log : function(string, args, logLevel, logSubject)
	{
		var logString = rp.Util.getCurrentDatetime(true) + ' - ' + vsprintf(string, args);

		if (logLevel == Logger.LEVEL_ERROR)
		{
			console.error(logString);
		}
		else if (logLevel == Logger.LEVEL_WARNING)
		{
			console.warn(logString);
		}
		else
		{
			console.info(logString);
		}
		
		rp.Util.saveFile(this.logFilePath, logString + '\n', true);
	},
	
	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
		
	//------------------------------------------------------------------------------------------------------------
}

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = Logger;

//------------------------------------------------------------------------------------------------------------
