var app = require('app');  // Module to control application life.
var path = require('path');
var BrowserWindow = require('browser-window');  // Module to create native browser window.

var rpDebug =
{
	OS_WINDOWS : 'windows',
	OS_LINUX : 'linux',
	
	IS_DEV : true,
	IS_OS : '',
};
rpDebug.IS_DEV = false;
rpDebug.IS_OS = rpDebug.OS_LINUX;

// Report crashes to our server.
require('crash-reporter').start();

// Keep a global reference of the window object, if you don't, the window will
// be closed automatically when the javascript object is GCed.
var mainWindow = null;

// Quit when all windows are closed.
app.on('window-all-closed', function()
{
	if (process.platform != 'darwin')
	{
		app.quit();
	}
});

// This method will be called when Electron has done everything
// initialization and ready for creating browser windows.
app.on('ready', function()
{
	mainWindow = new BrowserWindow({'width': 1366, 'height': 768, 'title': 'Immortals'});
	mainWindow.appBasePath = __dirname + '/';
	mainWindow.rpDebug = rpDebug;
	mainWindow.loadUrl('file://' + __dirname + '/index.html');
	
	if (rpDebug.IS_DEV == true)
	{
		mainWindow.openDevTools();
	}
	
	mainWindow.webContents.on('did-finish-load', function()
	{
	});

	mainWindow.on('close', function()
	{
		var executeString = 'rpEngine.logger.log("Shutting done RolePlanez engine.", [], rp.Logger.LEVEL_DEBUG, rp.Logger.SUBJECT_ENGINE)';
		mainWindow.webContents.executeJavaScript(executeString);
	});

	// Emitted when the window is closed.
	mainWindow.on('closed', function()
	{
		mainWindow = null;
	});
});