//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function Node_TowerOfNames_ChamberOfPhilosophy()
{
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

Node_TowerOfNames_ChamberOfPhilosophy.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	// Chamber of Philosophy
		// Entrance => Scroll (Self-Aspect) => Lens (Skill) => Art (Essence) => Exit

	enterNode : function()
	{
		this.action_sEntrance();
	},

	// Entrance

	action_sEntrance : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sEntrance_desc', {});
		
		rpEngine.game.addNarrativeAction(
				'sEntrance_cLook', 'action_sEntrance_cLook', 'towerOfNames_chamberOfPhilosophy_sEntrance_cLook_title', 'towerOfNames_chamberOfPhilosophy_sEntrance_cLook_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cPush', 'action_sEntrance_cPush', 'towerOfNames_chamberOfPhilosophy_sEntrance_cPush_title', 'towerOfNames_chamberOfPhilosophy_sEntrance_cPush_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cSmash', 'action_sEntrance_cSmash', 'towerOfNames_chamberOfPhilosophy_sEntrance_cSmash_title', 'towerOfNames_chamberOfPhilosophy_sEntrance_cSmash_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cStare', 'action_sEntrance_cStare', 'towerOfNames_chamberOfPhilosophy_sEntrance_cStare_title', 'towerOfNames_chamberOfPhilosophy_sEntrance_cStare_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cStory', 'action_sEntrance_cStory', 'towerOfNames_chamberOfPhilosophy_sEntrance_cStory_title', 'towerOfNames_chamberOfPhilosophy_sEntrance_cStory_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cBack', 'action_sEntrance_cBack', 'common_choice_goBack', '', '', {});
	},

		action_sEntrance_cBack : function()
		{
			rpEngine.game.setNextNodeIdLocation('towerOfNames_main');
		},
		
		action_sEntrance_cLook : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sEntrance_cLook_result', {});
			rpEngine.game.addNarrativeAction('sEntrance', 'action_sEntrance', 'common_choice_continue', '', '', {});
		},

		action_sEntrance_cPush : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sEntrance_cPush_result', {});
			rpEngine.game.addNarrativeAction('sEntrance', 'action_sEntrance', 'common_choice_continue', '', '', {});
		},

		action_sEntrance_cSmash : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sEntrance_cSmash_result', {});
			rpEngine.game.addNarrativeAction('sScroll', 'action_sScroll', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', -1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_insight', -1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_undyingScript', 1, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sEntrance_cStare : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sEntrance_cStare_result', {});
			rpEngine.game.addNarrativeAction('sScroll', 'action_sScroll', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_subterfuge', 1, false, true);
		},

		action_sEntrance_cStory : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sEntrance_cStory_result', {});
			rpEngine.game.addNarrativeAction('sScroll', 'action_sScroll', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_insight', 1, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

	// Scroll of Initiation

	action_sScroll : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_desc', {});
		
		rpEngine.game.addNarrativeAction('sScroll_cAlacrity', 'action_sScroll_cAlacrity', 'towerOfNames_chamberOfPhilosophy_sScroll_cAlacrity_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cAllure', 'action_sScroll_cAllure', 'towerOfNames_chamberOfPhilosophy_sScroll_cAllure_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cEmpathy', 'action_sScroll_cEmpathy', 'towerOfNames_chamberOfPhilosophy_sScroll_cEmpathy_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cFerocity', 'action_sScroll_cFerocity', 'towerOfNames_chamberOfPhilosophy_sScroll_cFerocity_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cInsight', 'action_sScroll_cInsight', 'towerOfNames_chamberOfPhilosophy_sScroll_cInsight_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cStoicism', 'action_sScroll_cStoicism', 'towerOfNames_chamberOfPhilosophy_sScroll_cStoicism_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cSubterfuge', 'action_sScroll_cSubterfuge', 'towerOfNames_chamberOfPhilosophy_sScroll_cSubterfuge_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cDiary', 'action_sScroll_cDiary', 'towerOfNames_chamberOfPhilosophy_sScroll_cDiary_title', '', '', {});
		rpEngine.game.addNarrativeAction('sScroll_cMusic', 'action_sScroll_cMusic', 'towerOfNames_chamberOfPhilosophy_sScroll_cMusic_title', '', '', {});
	},
		
		action_sScroll_cAlacrity : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cAlacrity_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_alacrity', 12, false, true);
		},

		action_sScroll_cAllure : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cAllure_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_allure', 12, false, true);
		},

		action_sScroll_cDiary : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cDiary_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('writingImplements', 5, true, {})
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_undyingScript', 7, false, true);
		},

		action_sScroll_cEmpathy : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cEmpathy_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', 12, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sScroll_cFerocity : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cFerocity_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 12, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sScroll_cInsight : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cInsight_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_insight', 12, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sScroll_cMusic : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cMusic_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_alacrity', 2, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_allure', 2, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', 2, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 2, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_insight', 2, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_stoicism', 2, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_subterfuge', 2, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sScroll_cStoicism : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cStoicism_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_stoicism', 12, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sScroll_cSubterfuge : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sScroll_cSubterfuge_result', {});
			rpEngine.game.addNarrativeAction('sLens', 'action_sLens', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_subterfuge', 12, false, true);
		},

	// Lens

	action_sLens : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_desc', {});

		rpEngine.game.addNarrativeAction('sLens_cGeneShaping', 'action_sLens_cGeneShaping', 'towerOfNames_chamberOfPhilosophy_sLens_cGeneShaping_title', '', '', {});
		rpEngine.game.addNarrativeAction('sLens_cInnerEsthetism', 'action_sLens_cInnerEsthetism', 'towerOfNames_chamberOfPhilosophy_sLens_cInnerEsthetism_title', '', '', {});
		rpEngine.game.addNarrativeAction('sLens_cLivingMedicine', 'action_sLens_cLivingMedicine', 'towerOfNames_chamberOfPhilosophy_sLens_cLivingMedicine_title', '', '', {});
		rpEngine.game.addNarrativeAction('sLens_cMortalDuelling', 'action_sLens_cMortalDuelling', 'towerOfNames_chamberOfPhilosophy_sLens_cMortalDuelling_title', '', '', {});
		rpEngine.game.addNarrativeAction('sLens_cPracticalArtifice', 'action_sLens_cPracticalArtifice', 'towerOfNames_chamberOfPhilosophy_sLens_cPracticalArtifice_title', '', '', {});
		rpEngine.game.addNarrativeAction('sLens_cPrescientCalculus', 'action_sLens_cPrescientCalculus', 'towerOfNames_chamberOfPhilosophy_sLens_cPrescientCalculus_title', '', '', {});
		rpEngine.game.addNarrativeAction(
					'sLens_cTreasure', 'action_sLens_cTreasure', 'towerOfNames_chamberOfPhilosophy_sLens_cTreasure_title', '', 'towerOfNames_chamberOfPhilosophy_sLens_cTreasure_info', {});
	},

		action_sLens_cGeneShaping : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cGeneShaping_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_geneShaping', 1, true, true);
		},

		action_sLens_cInnerEsthetism : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cInnerEsthetism_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_innerEsthetism', 3, true, true);
		},

		action_sLens_cLivingMedicine : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cLivingMedicine_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_livingMedicine', 3, true, true);
		},

		action_sLens_cMortalDuelling : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cMortalDuelling_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_mortalDuelling', 3, true, true);
		},

		action_sLens_cPracticalArtifice : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cPracticalArtifice_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_practicalArtifice', 3, true, true);
		},

		action_sLens_cPrescientCalculus : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cPrescientCalculus_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('skill_prescientCalculus', 1, true, true);
		},

		//TODO: Terminer les items à ajouter
		action_sLens_cTreasure : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sLens_cTreasure_result', {});
			rpEngine.game.addNarrativeAction('sArt', 'action_sArt', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('blackPetals', 200, true, {})
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('suppliesBasic', 10, true, {})
		},
		
	// Art

	action_sArt : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sArt_desc', {});

		rpEngine.game.addNarrativeAction('sArt_cBody', 'action_sArt_cBody', 'towerOfNames_chamberOfPhilosophy_sArt_cBody_title', 'towerOfNames_chamberOfPhilosophy_sArt_cBody_desc', '', {});
		rpEngine.game.addNarrativeAction('sArt_cMind', 'action_sArt_cMind', 'towerOfNames_chamberOfPhilosophy_sArt_cMind_title', 'towerOfNames_chamberOfPhilosophy_sArt_cMind_desc', '', {});
		rpEngine.game.addNarrativeAction('sArt_cSoul', 'action_sArt_cSoul', 'towerOfNames_chamberOfPhilosophy_sArt_cSoul_title', 'towerOfNames_chamberOfPhilosophy_sArt_cSoul_desc', '', {});
	},

		action_sArt_cBody : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sArt_cBody_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_body', 1, true, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_health', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sArt_cMind : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sArt_cMind_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_mind', 1, true, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

		action_sArt_cSoul : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sArt_cSoul_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_soul', 1, true, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_satisfaction', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

	// Exit

	action_sExit : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfPhilosophy_sExit_desc', {});
		rpEngine.game.addNarrativeAction('sExit_cContinue', 'action_sExit_cContinue', 'common_choice_continue', '', '', {});

		rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_mind', 1, true, true);
		rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
	},
			
		action_sExit_cContinue : function()
		{
			rpEngine.game.setVariable('progress_towerOfNames_chamberOfPhilosophy_done', 1);
			rpEngine.game.setNextNodeIdLocation('towerOfNames_main');
		},
		
	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
		
	//------------------------------------------------------------------------------------------------------------
}
Node_TowerOfNames_ChamberOfPhilosophy.inheritsFrom(rp.Node);

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = Node_TowerOfNames_ChamberOfPhilosophy;

//------------------------------------------------------------------------------------------------------------
