//------------------------------------------------------------------------------------------------------------
//CLASS DEFINITION
//------------------------------------------------------------------------------------------------------------

function Node_TowerOfNames_ChamberOfSubstance()
{
}

//------------------------------------------------------------------------------------------------------------
//CONSTANTS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//STATIC FUNCTIONS
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
//PROTOTYPE
//------------------------------------------------------------------------------------------------------------

Node_TowerOfNames_ChamberOfSubstance.prototype =
{
	//------------------------------------------------------------------------------------------------------------
	//VARIABLES
	//------------------------------------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------
	//GENERAL FUNCTIONS
	//------------------------------------------------------------------------------------------------------------

	// Chamber of Substance
		// Entrance => Mirror (Appearance) => Stories (Essence) => Tools (Item) => Exit

	enterNode : function()
	{
		this.action_sEntrance();
	},

	// Door

	action_sEntrance : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sEntrance_desc', {});
		
		rpEngine.game.addNarrativeAction(
				'sEntrance_cLook', 'action_sEntrance_cLook', 'towerOfNames_chamberOfSubstance_sEntrance_cLook_title', 'towerOfNames_chamberOfSubstance_sEntrance_cLook_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cPush', 'action_sEntrance_cPush', 'towerOfNames_chamberOfSubstance_sEntrance_cPush_title', 'towerOfNames_chamberOfSubstance_sEntrance_cPush_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cKick', 'action_sEntrance_cKick', 'towerOfNames_chamberOfSubstance_sEntrance_cKick_title', 'towerOfNames_chamberOfSubstance_sEntrance_cKick_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cTouch', 'action_sEntrance_cTouch', 'towerOfNames_chamberOfSubstance_sEntrance_cTouch_title', 'towerOfNames_chamberOfSubstance_sEntrance_cTouch_desc', '', {});
		rpEngine.game.addNarrativeAction(
				'sEntrance_cBack', 'action_sEntrance_cBack', 'common_choice_goBack', '', '', {});
	},
		
		action_sEntrance_cBack : function()
		{
			rpEngine.game.setNextNodeIdLocation('towerOfNames_main');
		},
		
		action_sEntrance_cKick : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sEntrance_cKick_result', {});
			rpEngine.game.addNarrativeAction('sMirror', 'action_sMirror', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 2, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sEntrance_cLook : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sEntrance_cLook_result', {});
			rpEngine.game.addNarrativeAction('sEntrance', 'action_sEntrance', 'common_choice_continue', '', '', {});
		},
		
		action_sEntrance_cPush : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sEntrance_cPush_result', {});
			rpEngine.game.addNarrativeAction('sMirror', 'action_sMirror', 'common_choice_continue', '', '');

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_stoicism', 2, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sEntrance_cTouch : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sEntrance_cTouch_result', {});
			rpEngine.game.addNarrativeAction('sMirror', 'action_sMirror', 'common_choice_continue', '', '');

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', 2, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
	// Silver Mirror

	action_sMirror : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sMirror_desc');
		
		var portraitSelectionMessageId = 'common_popup_playerActorPortraitSelection';
		var imageSelectionList = ['character_player_man_1', 'character_player_woman_1', 'character_player_experiment_1'];
		
		var action_sMirror_cMan = rpEngine.game.addNarrativeAction(
				'sMirror_cMan', 'action_sMirror_cMan', 'towerOfNames_chamberOfSubstance_sMirror_cMan_title', 'towerOfNames_chamberOfSubstance_sMirror_cMan_desc', '', {});
		action_sMirror_cMan.addNarrativeActionImageSelectionData(portraitSelectionMessageId, imageSelectionList);
		
		var action_sMirror_cWoman = rpEngine.game.addNarrativeAction(
				'sMirror_cWoman', 'action_sMirror_cWoman', 'towerOfNames_chamberOfSubstance_sMirror_cWoman_title', 'towerOfNames_chamberOfSubstance_sMirror_cWoman_desc', '', {});
		action_sMirror_cWoman.addNarrativeActionImageSelectionData(portraitSelectionMessageId, imageSelectionList);
		
		var action_sMirror_cHermaphrodite = rpEngine.game.addNarrativeAction(
				'sMirror_cHermaphrodite', 'action_sMirror_cHermaphrodite', 'towerOfNames_chamberOfSubstance_sMirror_cHermaphrodite_title',
				'towerOfNames_chamberOfSubstance_sMirror_cHermaphrodite_desc', '', {});
		action_sMirror_cHermaphrodite.addNarrativeActionImageSelectionData(portraitSelectionMessageId, imageSelectionList);
		
		var action_sMirror_cAsexual = rpEngine.game.addNarrativeAction('sMirror_cAsexual', 'action_sMirror_cAsexual', 'towerOfNames_chamberOfSubstance_sMirror_cAsexual_title',
				'towerOfNames_chamberOfSubstance_sMirror_cAsexual_desc', 'towerOfNames_chamberOfSubstance_sMirror_cAsexual_info', {});
		action_sMirror_cAsexual.addNarrativeActionImageSelectionData(portraitSelectionMessageId, imageSelectionList);
		
		var action_sMirror_cExperiment = rpEngine.game.addNarrativeAction('sMirror_cExperiment', 'action_sMirror_cExperiment', 'towerOfNames_chamberOfSubstance_sMirror_cExperiment_title',
				'towerOfNames_chamberOfSubstance_sMirror_cExperiment_desc', 'towerOfNames_chamberOfSubstance_sMirror_cExperiment_info', {});
		action_sMirror_cExperiment.addNarrativeActionImageSelectionData(portraitSelectionMessageId, imageSelectionList);
	},
		
		action_sMirror_cAsexual : function(data)
		{
			rpEngine.game.getPlayerActor().setPortraitImageId(data.imageSelectionList[0]);
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('trait_asexual', 1, true, true);
		
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sMirror_cAsexual_result', {});
			rpEngine.game.addNarrativeAction('sStories', 'action_sStories', 'common_choice_continue', '', '', {});
		},
		
		action_sMirror_cExperiment : function(data)
		{
			rpEngine.game.getPlayerActor().setPortraitImageId(data.imageSelectionList[0]);
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('trait_subjectiveShape', 1, true, true);
		
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sMirror_cExperiment_result', {});
			rpEngine.game.addNarrativeAction('sStories', 'action_sStories', 'common_choice_continue', '', '', {});
		},
		
		action_sMirror_cHermaphrodite : function(data)
		{
			rpEngine.game.getPlayerActor().setPortraitImageId(data.imageSelectionList[0]);
		
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sMirror_cHermaphrodite_result', {});
			rpEngine.game.addNarrativeAction('sStories', 'action_sStories', 'common_choice_continue', '', '', {});
		},
		
		action_sMirror_cMan : function(data)
		{
			rpEngine.game.getPlayerActor().setPortraitImageId(data.imageSelectionList[0]);
		
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sMirror_cMan_result', {});
			rpEngine.game.addNarrativeAction('sStories', 'action_sStories', 'common_choice_continue', '', '', {});
		},

		action_sMirror_cWoman : function(data)
		{
			rpEngine.game.getPlayerActor().setPortraitImageId(data.imageSelectionList[0]);
		
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sMirror_cWoman_result', {});
			rpEngine.game.addNarrativeAction('sStories', 'action_sStories', 'common_choice_continue', '', '', {});
		},

	// Stories

	action_sStories : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sStories_desc', {});
		
		rpEngine.game.addNarrativeAction('sStories_cConquerors', 'action_sStories_cConquerors', 'towerOfNames_chamberOfSubstance_sStories_cConquerors_title',
				'towerOfNames_chamberOfSubstance_sStories_cConquerors_desc', '', {});
		rpEngine.game.addNarrativeAction('sStories_cSeekers', 'action_sStories_cSeekers', 'towerOfNames_chamberOfSubstance_sStories_cSeekers_title',
				'towerOfNames_chamberOfSubstance_sStories_cSeekers_desc', '', {});
		rpEngine.game.addNarrativeAction('sStories_cArtists', 'action_sStories_cArtists', 'towerOfNames_chamberOfSubstance_sStories_cArtists_title',
				'towerOfNames_chamberOfSubstance_sStories_cArtists_desc', '', {});
	},

		action_sStories_cArtists : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sStories_cArtists_result', {});
			rpEngine.game.addNarrativeAction('sTools', 'action_sTools', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_soul', 1, true, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sStories_cConquerors : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sStories_cConquerors_result', {});
			rpEngine.game.addNarrativeAction('sTools', 'action_sTools', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_body', 1, true, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sStories_cSeekers : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sStories_cSeekers_result', {});
			rpEngine.game.addNarrativeAction('sTools', 'action_sTools', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_mind', 1, true, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},

	// Tools

	action_sTools : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_desc', {});
		
		rpEngine.game.addNarrativeAction('sTools_cWeapon', 'action_sTools_cWeapon', 'towerOfNames_chamberOfSubstance_sTools_cWeapon_title',
				'towerOfNames_chamberOfSubstance_sTools_cWeapon_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cClothes', 'action_sTools_cClothes', 'towerOfNames_chamberOfSubstance_sTools_cClothes_title',
				'towerOfNames_chamberOfSubstance_sTools_cClothes_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cLight', 'action_sTools_cLight', 'towerOfNames_chamberOfSubstance_sTools_cLight_title',
				'towerOfNames_chamberOfSubstance_sTools_cLight_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cUnderstand', 'action_sTools_cUnderstand', 'towerOfNames_chamberOfSubstance_sTools_cUnderstand_title',
				'towerOfNames_chamberOfSubstance_sTools_cUnderstand_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cProtection', 'action_sTools_cProtection', 'towerOfNames_chamberOfSubstance_sTools_cProtection_title',
				'towerOfNames_chamberOfSubstance_sTools_cProtection_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cVersatile', 'action_sTools_cVersatile', 'towerOfNames_chamberOfSubstance_sTools_cVersatile_title',
				'towerOfNames_chamberOfSubstance_sTools_cVersatile_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cCamouflage', 'action_sTools_cCamouflage', 'towerOfNames_chamberOfSubstance_sTools_cCamouflage_title',
				'towerOfNames_chamberOfSubstance_sTools_cCamouflage_desc', '', {});
		rpEngine.game.addNarrativeAction('sTools_cNothing', 'action_sTools_cNothing', 'towerOfNames_chamberOfSubstance_sTools_cNothing_title',
				'towerOfNames_chamberOfSubstance_sTools_cNothing_desc', 'towerOfNames_chamberOfSubstance_sTools_cNothing_info', {});
	},

		action_sTools_cCamouflage : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cCamouflage_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_subterfuge', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('lyingDice', 1, true, {isEquipped : true});
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cClothes : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cClothes_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_allure', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('shimmeringVeil', 1, true, {isEquipped : true});
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cLight : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cLight_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_insight', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('candleOfMysteries', 1, true, {isEquipped : true});
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cNothing : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cNothing_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_raw', 3, true, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_alacrity', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_allure', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_insight', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_stoicism', 1, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_subterfuge', 1, false, true);
			rpGlobalScriptMap.gameUtil.setPlayerActorStat('trait_ascetic', 1, 0, true);

			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cProtection : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cProtection_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_stoicism', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('stoneOfTemporisation', 1, true, {isEquipped : true});

			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cUnderstand : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cUnderstand_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_empathy', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('heartCompass', 1, true, {isEquipped : true});
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cVersatile : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cVersatile_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});
			
			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_alacrity', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('companionBreeze', 1, true, {isEquipped : true});
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
		
		action_sTools_cWeapon : function()
		{
			rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sTools_cWeapon_result', {});
			rpEngine.game.addNarrativeAction('sExit', 'action_sExit', 'common_choice_continue', '', '', {});

			rpGlobalScriptMap.gameUtil.changePlayerActorStat('selfAspect_ferocity', 3, false, true);
			rpGlobalScriptMap.gameUtil.changePlayerInventoryItem('fingerOfSteel', 1, true, {isEquipped : true});
			rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
		},
			
	// Exit

	action_sExit : function()
	{
		rpEngine.game.addTextGameLang('towerOfNames_chamberOfSubstance_sExit_desc', {});
		rpEngine.game.addNarrativeAction('sExit', 'action_sExit_cContinue', 'common_choice_continue', '', '', {});

		rpGlobalScriptMap.gameUtil.changePlayerActorStat('essence_body', 1, true, true);
		rpGlobalScriptMap.gameUtil.setPlayerActorStatListToMax(['currentStatus_coherence', 'currentStatus_health', 'currentStatus_satisfaction']);
	},
			
		action_sExit_cContinue : function()
		{
			rpEngine.game.setVariable('progress_towerOfNames_chamberOfSubstance_done', 1);
			rpEngine.game.setNextNodeIdLocation('towerOfNames_main');
		},

	//------------------------------------------------------------------------------------------------------------
	//GETTERS - SETTERS
	//------------------------------------------------------------------------------------------------------------
		
	//------------------------------------------------------------------------------------------------------------
}
Node_TowerOfNames_ChamberOfSubstance.inheritsFrom(rp.Node);

//------------------------------------------------------------------------------------------------------------
//EXPORTS
//------------------------------------------------------------------------------------------------------------

module.exports = Node_TowerOfNames_ChamberOfSubstance;

//------------------------------------------------------------------------------------------------------------
	